#ifndef CFLIRONECONTROL_H
#define CFLIRONECONTROL_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tga.h"

#define VENDOR_ID	0x09cb
#define PRODUCT_ID	0x1996

#define IMAGE_BUFFER_SIZE 1048576

//класс управления Flir One
class CFlirOneControl
{
 protected:
  //-Переменные класса-------------------------------------------------------  
  unsigned char *ImageBuffer;//буфер сборки пакета данных с изображением
  unsigned long ImageBufferSize;//количество данных в буфере сборки изображения
  long ImageIndex;//индекс сохраняемого изображения

  unsigned char ColorMap_R[256];//карта перекодировки изображения
  unsigned char ColorMap_G[256];//карта перекодировки изображения
  unsigned char ColorMap_B[256];//карта перекодировки изображения
  
  char *Path;//рабочий каталог
  //-Функции класса----------------------------------------------------------
  //-Прочее------------------------------------------------------------------
 public:
  //-Конструктор класса------------------------------------------------------
  CFlirOneControl(void);
  //-Деструктор класса-------------------------------------------------------
  ~CFlirOneControl();
  //-Переменные класса-------------------------------------------------------
  //-Функции класса----------------------------------------------------------
  void SetPath(char *path);//задать рабочий каталог
  bool CreateImage(unsigned char *buffer,unsigned long size);//создать изображение
  bool LoadColorMap(char *filename);//загрузить карту перекодировки изображения
  //-Прочее------------------------------------------------------------------
 protected:
  void CalculateCRC(unsigned short &crc,unsigned char byte);//вычислить crc
  void AddLog(char *string);//добавить строку в log-файл
};

#endif
